// |---------------------------------------------------------|
// |                                                         |
// |      Virtual Pascal Runtime Library.  Version 2.1.      |
// |      Test classes for the System unit                   |
// |      ---------------------------------------------------|
// |      Copyright (C) 2003 vpascal.com                     |
// |---------------------------------------------------------|

unit SysTest;

interface

{&Delphi+,Use32+}

uses
  VpSysLow, Classes, SysUtils, UnitTest, Math;

type
  tCommandLineTest = class(tTest)
  public
    function Run: Boolean; override;
  end;

  tSysTest = class(tTest)
  public
    function Run: Boolean; override;
  end;

implementation

// Command line test - assumes that the test program is called
// with 3 parameters, like this: AllTest Bob "Fred Smith" John
function tCommandLineTest.Run: Boolean;
var
  ModName: Array[0..260] of char;
  p, q: PChar;
begin
  // Test ParamCount and ParamStr
  Result := Test(ParamCount = 3, 'Paramcount');
  Result := Result and Test(ParamStr(1) = 'Bob', '1st param = Bob');
  Result := Result and Test(ParamStr(2) = 'Fred Smith', '2nd param = Fred Smith');
  Result := Result and Test(ParamStr(3) = 'John', '3rd param = John');
  Result := Result and Test(ParamStr(4) = '', '4rd param = empty');

  // Test ParamStr(0)
  SysCtrlGetModuleName(0, ModName);
  Result := Result and Test(ParamStr(0) = StrPas(ModName), 'Module name equal '+ParamStr(0)+' '+Strpas(ModName));
  Result := Result and Test(Length(ParamStr(0)) > 5, 'Length of Module name');

  // Test CmdLine
  p := StrRScan(CmdLine, SysPathSep);
  if p = nil then p := CmdLine else inc(p);
  q := StrRScan(ModName, SysPathSep);
  if q = nil then q := ModName else inc(q);
  Result := Result and Test(StrIComp(p, q) = 0, 'CmdLine 0-terminated');
end;

function tSysTest.Run: Boolean;
begin
  // Does nothing yes
  Result := True;
end;

begin
  RegisterTests( [tSysTest, tCommandLineTest] );
end.

