{Simple demo using Glide2x

        * Gouraud Shaded Triangles
        * Backface Culling
        * Z buffering

        by Kenn Power - kenn.p@virgin.net
        22/09/2000

}



program Zbuffertest;
uses
        crt,glide2x,math;

const   NumCubes=64;
        acceleration:single=0.1;

type
        Tcube=record
                        x,y,z,a1,a2,ai1,ai2,xi,yi,zi:single;
                        r,g,b:array[0..7] of byte;
                        size:integer;
                        end;

        Tcubearray=array[0..NumCubes] of Tcube;


var
        context:TFxBool;
        cube:TCubeArray;
        CentreX,CentreY,centreZ:integer;


procedure setupcubes;
var i,u:integer;
begin
        randomize;
        for i:=0 to NumCubes do with cube[i] do begin
                x:=(random(800)-400);
                y:=(random(800)-400);
                z:=CentreZ+(random((CentreZ*2)-100)+100);
                xi:=0;
                yi:=0;
                zi:=0;
                a1:=DegtoRad(random(360));
                a2:=DegtoRad(random(360));
                ai1:=degToRad(random(16)-8);
                ai2:=degToRad(random(16)-8);
                size:=32{8+random(32)};
                for u:=0 to 7 do begin
                        r[u]:=random(256);
                        g[u]:=random(256);
                        b[u]:=random(256);
                        end;
        end;
end;



procedure drawcubes;
var P:array[0..7] of TGrVertex;
    i,u:integer;
    nx,ny,nz:single;

begin
        for i:=0 to NumCubes do with cube[i] do begin

        {Clamp the Z offset to somthing sensible}
        if z<50 then z:=50;

        {Move Structure for cube into P}
        p[0].x:=-size;p[0].y:=-size;p[0].z:=+size;p[0].r:=r[0];p[0].g:=g[0];p[0].b:=b[0];p[0].a:=0;
        p[1].x:=+size;p[1].y:=-size;p[1].z:=+size;p[1].r:=r[1];p[1].g:=g[1];p[1].b:=b[1];p[1].a:=0;
        p[2].x:=+size;p[2].y:=-size;p[2].z:=-size;p[2].r:=r[2];p[2].g:=g[2];p[2].b:=b[2];p[2].a:=0;
        p[3].x:=-size;p[3].y:=-size;p[3].z:=-size;p[3].r:=r[3];p[3].g:=g[3];p[3].b:=b[3];p[3].a:=0;
        p[4].x:=-size;p[4].y:=+size;p[4].z:=+size;p[4].r:=r[4];p[4].g:=g[4];p[4].b:=b[4];p[4].a:=0;
        p[5].x:=+size;p[5].y:=+size;p[5].z:=+size;p[5].r:=r[5];p[5].g:=g[5];p[5].b:=b[5];p[5].a:=0;
        p[6].x:=+size;p[6].y:=+size;p[6].z:=-size;p[6].r:=r[6];p[6].g:=g[6];p[6].b:=b[6];p[6].a:=0;
        p[7].x:=-size;p[7].y:=+size;p[7].z:=-size;p[7].r:=r[7];p[7].g:=g[7];p[7].b:=b[7];p[7].a:=0;

        {Rotate P}
        for u:=0 to 7 do begin
                {Rotate around XY}
                nx:=((p[u].x*-cos(a1)))-((p[u].y*sin(a1)));
                ny:=((p[u].x*sin(a1)))+((p[u].y*-cos(a1)));
                p[u].x:=nx;
                p[u].y:=ny;
                {Rotate around YZ}
                ny:=((p[u].y*-cos(a2)))-((p[u].z*sin(a2)));
                nz:=((p[u].y*sin(a2)))+((p[u].z*-cos(a2)));
                p[u].y:=ny;
                {Add the Zoffset to Z}
                p[u].z:=nz+z;

        end;

        {add the offsets, project and correct to the screens centre}
        for u:=0 to 7 do begin
                p[u].x:=((x+p[u].x)*(500/(500+p[u].z)))+centreX;
                p[u].y:=((y+p[u].y)*(500/(500+p[u].z)))+centreY;
        end;


        {Copy z into ooz for simple zbuffering - Scale ooz for 0 to just less than 65535}
        for u:=0 to 7 do
                p[u].ooz:=(p[u].z/(centreZ*2)*65000);


        {Draw the cube}
        grDrawTriangle(p[0],p[1],p[2]);
        grDrawTriangle(p[0],p[2],p[3]);
        grDrawTriangle(p[0],p[5],p[1]);
        grDrawTriangle(p[0],p[4],p[5]);
        grDrawTriangle(p[1],p[5],p[6]);
        grDrawTriangle(p[1],p[6],p[2]);
        grDrawTriangle(p[2],p[6],p[7]);
        grDrawTriangle(p[2],p[7],p[3]);
        grDrawTriangle(p[3],p[4],p[0]);
        grDrawTriangle(p[3],p[7],p[4]);
        grDrawTriangle(p[4],p[6],p[5]);
        grDrawTriangle(p[4],p[7],p[6]);

        {Move the cubes position and rotation}
        if x<0 then xi:=xi+acceleration else xi:=xi-acceleration;
        if y<0 then yi:=yi+acceleration else yi:=yi-acceleration;
        if z<centrez then zi:=zi+acceleration else zi:=zi-acceleration;

        x:=x+xi;
        y:=y+yi;
        z:=z+zi;

        a1:=a1+ai1;
        a2:=a2+ai2;
        end;
end;


begin
        if not GlideUnitIsInitalised then begin
                writeln('Glide Unit Not Intialised.');
                halt(1);
                end;

        grGlideInit;
        grSstSelect(0);
        context:= grSstWinOpen( 0, GR_RESOLUTION_640x480, GR_REFRESH_60Hz,
                          GR_COLORFORMAT_RGBA, GR_ORIGIN_UPPER_LEFT, 2, 1);

        CentreX:=320;
        CentreY:=240;
        CentreZ:=2000;

        grRenderBuffer(gr_Buffer_BackBuffer);

        grCullMode(gr_Cull_Negative);
        grDepthBufferMode(gr_DepthBuffer_Zbuffer);
        grDepthMask(FxTrue);

        grDepthBufferFunction(Gr_Cmp_Less);

        setupcubes;

        repeat
                grBufferClear(0,0,$ffff); {colour black,Alpha 0,zdepth}
                drawcubes;
                grBufferSwap(1);{wait for a 1 retrace}
        until keypressed;


        grSstWinClose;
        grGlideShutdown;

end.


