function DoFormatStr(const FmtStr: String; var Param): String;
var
  Buffer: array[0..255] of Char;
  FmtStrZ: array[0..255] of Char;
begin
  StrPCopy(FmtStrZ, FmtStr);
  WVSPrintF(Buffer, FmtStrZ, Param);
  DoFormatStr := StrPas(Buffer);
end;

procedure DebugMessage(Message,WParam,LParam: Longint);
var
  S: String;
const
  Opened: Boolean = False;
begin
  if not Opened then
  begin
    Assign(System.Output, 'S:\LOG.TXT');
    Rewrite(System.Output);
    Opened := True;
  end;

  case Message of
    WM_NULL                   : S := 'WM_NULL';
    WM_CREATE                 : S := 'WM_CREATE';
    WM_DESTROY                : S := 'WM_DESTROY';
    WM_MOVE                   : S := 'WM_MOVE';
    WM_SIZE                   : S := 'WM_SIZE';
    WM_ACTIVATE               : S := 'WM_ACTIVATE';
    WM_SETFOCUS               : S := 'WM_SETFOCUS';
    WM_KILLFOCUS              : S := 'WM_KILLFOCUS';
    WM_ENABLE                 : S := 'WM_ENABLE';
    WM_SETREDRAW              : S := 'WM_SETREDRAW';
    WM_SETTEXT                : S := 'WM_SETTEXT';
    WM_GETTEXT                : S := 'WM_GETTEXT';
    WM_GETTEXTLENGTH          : S := 'WM_GETTEXTLENGTH';
    WM_PAINT                  : S := 'WM_PAINT';
    WM_CLOSE                  : S := 'WM_CLOSE';
    WM_QUERYENDSESSION        : S := 'WM_QUERYENDSESSION';
    WM_QUIT                   : S := 'WM_QUIT';
    WM_QUERYOPEN              : S := 'WM_QUERYOPEN';
    WM_ERASEBKGND             : S := 'WM_ERASEBKGND';
    WM_SYSCOLORCHANGE         : S := 'WM_SYSCOLORCHANGE';
    WM_ENDSESSION             : S := 'WM_ENDSESSION';
    WM_SHOWWINDOW             : S := 'WM_SHOWWINDOW';
    WM_WININICHANGE           : S := 'WM_WININICHANGE';
    WM_DEVMODECHANGE          : S := 'WM_DEVMODECHANGE';
    WM_ACTIVATEAPP            : S := 'WM_ACTIVATEAPP';
    WM_FONTCHANGE             : S := 'WM_FONTCHANGE';
    WM_TIMECHANGE             : S := 'WM_TIMECHANGE';
    WM_CANCELMODE             : S := 'WM_CANCELMODE';
    WM_SETCURSOR              : S := 'WM_SETCURSOR';
    WM_MOUSEACTIVATE          : S := 'WM_MOUSEACTIVATE';
    WM_CHILDACTIVATE          : S := 'WM_CHILDACTIVATE';
    WM_QUEUESYNC              : S := 'WM_QUEUESYNC';
    WM_GETMINMAXINFO          : S := 'WM_GETMINMAXINFO';
    WM_PAINTICON              : S := 'WM_PAINTICON';
    WM_ICONERASEBKGND         : S := 'WM_ICONERASEBKGND';
    WM_NEXTDLGCTL             : S := 'WM_NEXTDLGCTL';
    WM_SPOOLERSTATUS          : S := 'WM_SPOOLERSTATUS';
    WM_DRAWITEM               : S := 'WM_DRAWITEM';
    WM_MEASUREITEM            : S := 'WM_MEASUREITEM';
    WM_DELETEITEM             : S := 'WM_DELETEITEM';
    WM_VKEYTOITEM             : S := 'WM_VKEYTOITEM';
    WM_CHARTOITEM             : S := 'WM_CHARTOITEM';
    WM_SETFONT                : S := 'WM_SETFONT';
    WM_GETFONT                : S := 'WM_GETFONT';
    WM_SETHOTKEY              : S := 'WM_SETHOTKEY';
    WM_GETHOTKEY              : S := 'WM_GETHOTKEY';
    WM_QUERYDRAGICON          : S := 'WM_QUERYDRAGICON';
    WM_COMPAREITEM            : S := 'WM_COMPAREITEM';
    WM_COMPACTING             : S := 'WM_COMPACTING';
    WM_WINDOWPOSCHANGING      : S := 'WM_WINDOWPOSCHANGING';
    WM_WINDOWPOSCHANGED       : S := 'WM_WINDOWPOSCHANGED';
    WM_POWER                  : S := 'WM_POWER';
    WM_COPYDATA               : S := 'WM_COPYDATA';
    WM_CANCELJOURNAL          : S := 'WM_CANCELJOURNAL';
    WM_NOTIFY                 : S := 'WM_NOTIFY';
    WM_HELP                   : S := 'WM_HELP';
    WM_SETICON                : S := 'WM_SETICON';
    WM_NCCREATE               : S := 'WM_NCCREATE';
    WM_NCDESTROY              : S := 'WM_NCDESTROY';
    WM_NCCALCSIZE             : S := 'WM_NCCALCSIZE';
    WM_NCHITTEST              : S := 'WM_NCHITTEST';
    WM_NCPAINT                : S := 'WM_NCPAINT';
    WM_NCACTIVATE             : S := 'WM_NCACTIVATE';
    WM_GETDLGCODE             : S := 'WM_GETDLGCODE';
    WM_NCMOUSEMOVE            : S := 'WM_NCMOUSEMOVE';
    WM_NCLBUTTONDOWN          : S := 'WM_NCLBUTTONDOWN';
    WM_NCLBUTTONUP            : S := 'WM_NCLBUTTONUP';
    WM_NCLBUTTONDBLCLK        : S := 'WM_NCLBUTTONDBLCLK';
    WM_NCRBUTTONDOWN          : S := 'WM_NCRBUTTONDOWN';
    WM_NCRBUTTONUP            : S := 'WM_NCRBUTTONUP';
    WM_NCRBUTTONDBLCLK        : S := 'WM_NCRBUTTONDBLCLK';
    WM_NCMBUTTONDOWN          : S := 'WM_NCMBUTTONDOWN';
    WM_NCMBUTTONUP            : S := 'WM_NCMBUTTONUP';
    WM_NCMBUTTONDBLCLK        : S := 'WM_NCMBUTTONDBLCLK';
    WM_KEYDOWN                : S := 'WM_KEYDOWN';
    WM_KEYUP                  : S := 'WM_KEYUP';
    WM_CHAR                   : S := 'WM_CHAR';
    WM_DEADCHAR               : S := 'WM_DEADCHAR';
    WM_SYSKEYDOWN             : S := 'WM_SYSKEYDOWN';
    WM_SYSKEYUP               : S := 'WM_SYSKEYUP';
    WM_SYSCHAR                : S := 'WM_SYSCHAR';
    WM_SYSDEADCHAR            : S := 'WM_SYSDEADCHAR';
    WM_INITDIALOG             : S := 'WM_INITDIALOG';
    WM_COMMAND                : S := 'WM_COMMAND';
    WM_SYSCOMMAND             : S := 'WM_SYSCOMMAND';
    WM_TIMER                  : S := 'WM_TIMER';
    WM_HSCROLL                : S := 'WM_HSCROLL';
    WM_VSCROLL                : S := 'WM_VSCROLL';
    WM_INITMENU               : S := 'WM_INITMENU';
    WM_INITMENUPOPUP          : S := 'WM_INITMENUPOPUP';
    WM_MENUSELECT             : S := 'WM_MENUSELECT';
    WM_MENUCHAR               : S := 'WM_MENUCHAR';
    WM_ENTERIDLE              : S := 'WM_ENTERIDLE';
    WM_CTLCOLORMSGBOX         : S := 'WM_CTLCOLORMSGBOX';
    WM_CTLCOLOREDIT           : S := 'WM_CTLCOLOREDIT';
    WM_CTLCOLORLISTBOX        : S := 'WM_CTLCOLORLISTBOX';
    WM_CTLCOLORBTN            : S := 'WM_CTLCOLORBTN';
    WM_CTLCOLORDLG            : S := 'WM_CTLCOLORDLG';
    WM_CTLCOLORSCROLLBAR      : S := 'WM_CTLCOLORSCROLLBAR';
    WM_CTLCOLORSTATIC         : S := 'WM_CTLCOLORSTATIC';
    WM_MOUSEMOVE              : S := 'WM_MOUSEMOVE';
    WM_LBUTTONDOWN            : S := 'WM_LBUTTONDOWN';
    WM_LBUTTONUP              : S := 'WM_LBUTTONUP';
    WM_LBUTTONDBLCLK          : S := 'WM_LBUTTONDBLCLK';
    WM_RBUTTONDOWN            : S := 'WM_RBUTTONDOWN';
    WM_RBUTTONUP              : S := 'WM_RBUTTONUP';
    WM_RBUTTONDBLCLK          : S := 'WM_RBUTTONDBLCLK';
    WM_MBUTTONDOWN            : S := 'WM_MBUTTONDOWN';
    WM_MBUTTONUP              : S := 'WM_MBUTTONUP';
    WM_MBUTTONDBLCLK          : S := 'WM_MBUTTONDBLCLK';
    WM_PARENTNOTIFY           : S := 'WM_PARENTNOTIFY';
    WM_ENTERMENULOOP          : S := 'WM_ENTERMENULOOP';
    WM_EXITMENULOOP           : S := 'WM_EXITMENULOOP';
    WM_MDICREATE              : S := 'WM_MDICREATE';
    WM_MDIDESTROY             : S := 'WM_MDIDESTROY';
    WM_MDIACTIVATE            : S := 'WM_MDIACTIVATE';
    WM_MDIRESTORE             : S := 'WM_MDIRESTORE';
    WM_MDINEXT                : S := 'WM_MDINEXT';
    WM_MDIMAXIMIZE            : S := 'WM_MDIMAXIMIZE';
    WM_MDITILE                : S := 'WM_MDITILE';
    WM_MDICASCADE             : S := 'WM_MDICASCADE';
    WM_MDIICONARRANGE         : S := 'WM_MDIICONARRANGE';
    WM_MDIGETACTIVE           : S := 'WM_MDIGETACTIVE';
    WM_MDISETMENU             : S := 'WM_MDISETMENU';
    WM_DROPFILES              : S := 'WM_DROPFILES';
    WM_MDIREFRESHMENU         : S := 'WM_MDIREFRESHMENU';
    WM_CUT                    : S := 'WM_CUT';
    WM_COPY                   : S := 'WM_COPY';
    WM_PASTE                  : S := 'WM_PASTE';
    WM_CLEAR                  : S := 'WM_CLEAR';
    WM_UNDO                   : S := 'WM_UNDO';
    WM_RENDERFORMAT           : S := 'WM_RENDERFORMAT';
    WM_RENDERALLFORMATS       : S := 'WM_RENDERALLFORMATS';
    WM_DESTROYCLIPBOARD       : S := 'WM_DESTROYCLIPBOARD';
    WM_DRAWCLIPBOARD          : S := 'WM_DRAWCLIPBOARD';
    WM_PAINTCLIPBOARD         : S := 'WM_PAINTCLIPBOARD';
    WM_VSCROLLCLIPBOARD       : S := 'WM_VSCROLLCLIPBOARD';
    WM_SIZECLIPBOARD          : S := 'WM_SIZECLIPBOARD';
    WM_ASKCBFORMATNAME        : S := 'WM_ASKCBFORMATNAME';
    WM_CHANGECBCHAIN          : S := 'WM_CHANGECBCHAIN';
    WM_HSCROLLCLIPBOARD       : S := 'WM_HSCROLLCLIPBOARD';
    WM_QUERYNEWPALETTE        : S := 'WM_QUERYNEWPALETTE';
    WM_PALETTEISCHANGING      : S := 'WM_PALETTEISCHANGING';
    WM_PALETTECHANGED         : S := 'WM_PALETTECHANGED';
    WM_HOTKEY                 : S := 'WM_HOTKEY';
    WM_DDE_INITIATE           : S := 'WM_DDE_INITIATE';
    WM_DDE_TERMINATE          : S := 'WM_DDE_TERMINATE';
    WM_DDE_ADVISE             : S := 'WM_DDE_ADVISE';
    WM_DDE_UNADVISE           : S := 'WM_DDE_UNADVISE';
    WM_DDE_ACK                : S := 'WM_DDE_ACK';
    WM_DDE_DATA               : S := 'WM_DDE_DATA';
    WM_DDE_REQUEST            : S := 'WM_DDE_REQUEST';
    WM_DDE_POKE               : S := 'WM_DDE_POKE';
    WM_DDE_EXECUTE            : S := 'WM_DDE_EXECUTE';
    BM_GETCHECK               : S := 'BM_GETCHECK';
    BM_SETCHECK               : S := 'BM_SETCHECK';
    BM_GETSTATE               : S := 'BM_GETSTATE';
    BM_SETSTATE               : S := 'BM_SETSTATE';
    BM_SETSTYLE               : S := 'BM_SETSTYLE';
    BM_CLICK                  : S := 'BM_CLICK';
    BM_GETIMAGE               : S := 'BM_GETIMAGE';
    BM_SETIMAGE               : S := 'BM_SETIMAGE';
    else S := DoFormatStr('%8lx', Message);
  end;
  WriteLn('Message = ', S:20, '  ',
          'WParam  = ', DoFormatStr('%8lx', WParam), '  ',
          'LParam  = ', DoFormatStr('%8lx', LParam));
end;
