// signed 64-bit integer manipulattion (TQuad,comp)
{$S-,R-,Q-,I-,X+,T-,Cdecl-,OrgName-,AlignRec-,Use32+}

unit int64;

interface

Uses
  VpSysLow;

procedure quad_or (Var Op1: TQuad; const Op2: TQuad);
procedure quad_and(Var Op1: TQuad; const Op2: TQuad);
//function quad_div(Operand, Divisor: TQuad): TQuad;
{function smod(Operand, Divisor: Cardinal): Cardinal;
function smul(Op1, Op2: Cardinal; HighLong: PCardinal): Cardinal;
function sdivmod(Operand, Divisor: Cardinal; var Modulus: Cardinal): Cardinal;}
function squad2str(Value: TQuad): ShortString;
function squad2str_scale(Value: TQuad; MaxLen: Word): ShortString;

implementation

procedure quad_or (Var Op1: TQuad; const Op2: TQuad);
  {&Frame-}{&Uses eax,esi,edi}
  asm
    mov esi,Offset Op2
    mov edi,[Op1]
    mov eax,TQuadRec[esi].Lo
    or  TQuadRec[esi].Lo,eax
    mov eax,TQuadRec[esi].Hi
    or  TQuadRec[esi].Hi,eax
  end;

procedure quad_and(Var Op1: TQuad; const Op2: TQuad);
  {&Frame-}{&Uses eax,esi,edi}
  asm
    mov esi,Offset [Op2]
    mov edi,Op1
    mov eax,TQuadRec[esi].Lo
    and TQuadRec[esi].Lo,eax
    mov eax,TQuadRec[esi].Hi
    and TQuadRec[esi].Hi,eax
  end;

(*unsure..
function quad_div(Operand, Divisor: TQuad): TQuad;assembler;
  {&Frame-}{&Uses eax}
  var
    org_cw              :SmallWord;
  const
    round_down_cw
  asm
    fstcw org_cw
    fldcw round_down_cw

    fild Operand
    fild Divisor
    fdivp ST(1),ST(0)
    frndint

    fldcw org_cw
  end;*)

{
function smod(Operand, Divisor: Cardinal): Cardinal;
function smul(Op1, Op2: Cardinal; HighLong: PCardinal): Cardinal;
function sdivmod(Operand, Divisor: Cardinal; var Modulus: Cardinal): Cardinal;}

function squad2str(Value: TQuad): ShortString;assembler;
  {&Frame-}{&Uses eax,esi,edi,ecx}
  var
    tmp                 :array[0..40] of char;
  const
    integer10           :longint=10;
    mSW_C0              = $0100;// Condition bit 0
    mSW_C3              = $4000;// Condition bit 3
  asm
    lea esi,[tmp]
    sub ecx,ecx
    mov edi,@Result
    inc edi                     // skip result length
    cld
    fild [Value]                // ST(0)=Value
    ftst                        // negative?
    fnstsw ax
    test ax,mSW_C0              // < 0 -> C0=1
    jz @not_negative

    mov al,'-'                  // save sign
    stosb
    fabs                        // continue with absolute value

  @not_negative:

  @next_figure:
    fld ST(0)                   // ST(0)=Value ST(1)=Value
    fild [integer10]            // ST(0)=10 ST(1)=Value ST(2)=Value
    fxch ST(1)                  // ST(0)=Value ST(1)=10 ST(2)=Value
    fprem1                      // ST(0)=Value "mod" 10 ST(1)=10 ST(2)=Value
    ftst                        // ST(0)<0?
    fnstsw ax
    test ax,mSW_C0              // < 0 -> C0=1
    jz @not_mod_negative
    fadd ST(0),ST(1)
 @not_mod_negative:             // ST(0)=[0..9]
    fist [esi].Longint          // save Value mod 10
    inc esi
    inc ecx
    fsubp St(2),ST(0)           // ST(0)=10 ST(1)=Value-Value mod 10
    fdivp ST(1),ST(0)           // ST(0)=(Value-Value mod 10)/10
    fwait
    ftst                        // reached zero?
    fnstsw ax
    test ax,mSW_C3              // +- 0? -> C3=1
    jz @next_figure

    fstp [esi].Double           // trow away ST(0) to dummy location

  @reverse_figures_loop:
    dec esi
    mov al,[esi]
    or al,'0'
    stosb
    loop @reverse_figures_loop

    mov esi,@Result             // set length byte
    mov eax,edi
    sub eax,esi
    dec eax
    mov [esi],al

  end;

(* convert filesize to 9 chars for TV file picker *)
function squad2str_scale(Value: TQuad; MaxLen: Word): ShortString;
  var
    Scale: Word;
    tmp: String;
  const
    scale_table:array[1..6] of String[3]=(' Ki',' Mi',' Gi',' Ti', ' Pi', ' Ei');

  begin
    Scale := 0;
    tmp := squad2str(Value);
    while (Length(tmp) > MaxLen) and (scale<High(scale_table)) do
      begin
        Inc(Scale);
        Value := Value/1024.0;
        tmp := squad2str(Value)+scale_table[Scale];
      end;

    squad2str_scale := tmp;
  end;

end.

