//
//                                                       
//      Virtual Pascal Runtime Library.  Version 2.1.    
//      Printer Interface Unit                           
//      
//      Copyright (C) 2000 vpascal.com                   
//                                                       
//

// To write text to the printer, simply use Write statements:
//
// Writeln(Lst, 'This is a printer test');
//
// To force a new page, call the FormFeed routine:
//
// FormFeed;

unit Printer;

{$I-,S-}

interface

var
  Lst: Text;

procedure FormFeed;

implementation

const
  cFormFeed = #12;

(*$IFDEF DPMI32*)
procedure set_binary_mode(const handle:longint);(*$FRAME-*)(*$USES EAX,EBX,EDX*)
  asm
    mov eax,$4400 // get device information
    mov ebx,handle
    int $21       // -> DX
    jc @ret

//  14    device driver can process IOCTL requests (see AX=4402h"DOS 2+")
//  13    output until busy supported
//  11    driver supports OPEN/CLOSE calls
//   8    ??? (set by MS-DOS 6.2x KEYB)
//   7    set (indicates device)
//   6    EOF on input
//   5    raw (binary) mode
//   4    device is special (uses INT 29)
//   3    clock device
//   2    NUL device
//   1    standard output
//   0    standard input
   or dl,(1 shl 5)
   mov dh,0

   mov eax,$4401  // set device information
   int $21
  @ret:
  end;
(*$ENDIF*)

procedure InitPrinter;
begin
  Assign(Lst,'LPT1');
  Rewrite(Lst);
  (*$IFDEF DPMI32*)
  // TextRec.handle (System/Dos)
  set_binary_mode(MemL[Ofs(Lst)]);
  (*$ENDIF*)
end;

procedure FormFeed;
begin
  Write(Lst, cFormFeed);
  Close(Lst);
  InOutRes := 0;
  InitPrinter;
end;

initialization
  InitPrinter;
end.

